"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var ReactDOM = tslib_1.__importStar(require("react-dom"));
require("./styles");
var react_router_dom_1 = require("react-router-dom");
var history_1 = require("./common/history");
var react_ga_1 = tslib_1.__importDefault(require("react-ga"));
var app_1 = tslib_1.__importDefault(require("./views/app"));
var provider_1 = require("@rmwc/provider");
var renderApp = function (Component) {
    ReactDOM.render(react_1.default.createElement(provider_1.RMWCProvider, null,
        react_1.default.createElement(react_router_dom_1.Router, { history: history_1.history },
            react_1.default.createElement(Component, { location: window.location.href }))), document.getElementById('root'));
};
// @ts-ignore
if (module.hot) {
    // @ts-ignore
    module.hot.accept(['./views/app'], function () { return renderApp(app_1.default); });
}
var initAnalytics = function () {
    react_ga_1.default.initialize(process.env.REACT_APP_GOOGLE_ANALYTICS_ID);
    var doPageView = function () {
        return react_ga_1.default.pageview(window.location.pathname + window.location.search);
    };
    history_1.history.listen(function () { return doPageView(); });
    doPageView();
};
var init = function () {
    renderApp(app_1.default);
    initAnalytics();
};
exports.default = init;
